ManaNotifierDB = {}

local function sendMessage(msg)
	msg = msg or ""
	if IsInRaid() then
		SendChatMessage(msg, "RAID")
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		SendChatMessage(msg, "INSTANCE_CHAT")
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		SendChatMessage(msg, "PARTY")
	end
end

local function isNumeric(value)
    if value == tostring(tonumber(value)) then
        return true
    else
        return false
    end
end

local function isempty(s)
  return s == nil or s == ''
end

local sendWarning = false
local sendReady = true
local active = true
local warning = 10
local rewarn = 20
local ready = 60
local repeats = 2

local function AddonCommands(msg, editbox)
	local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
	
	if isempty(cmd) then
		print("|cff2020ffManaNotifier|r\n/mn start -> Start ManaNotifier \n/mn stop -> Stop ManaNotifier \n/mn setw <val> -> Warning percent \n/mn setrew <val> -> Rewarn after \n/mn setr <val> -> Ready after\n/mn setrep <val> -> Set Warning-Message repetition\n/mn info -> Show setted values");
		return
	end
	
	if cmd == "start" then
		print("Started |cff2020ffManaNotifier|r")
		active = true
		ManaNotifierDB.active = true
		return
	elseif cmd == "stop" then
		print("Stoppen |cff2020ffManaNotifier|r")
		active = false
		ManaNotifierDB.active = false
		return
	end
	if cmd == "info" then
		if active then
			print("|cff2020ffManaNotifier|r\nActive: activated\nWarning: " .. warning .. "%\nRewarn: " .. rewarn .. "%\nReady: " .. ready .. "%\n" .. "Warning Repetition: " .. repeats)
		else
			print("|cff2020ffManaNotifier|r\nActive: deactivated\nWarning: " .. warning .. "%\nRewarn: " .. rewarn .. "%\nReady: " .. ready .. "%\n" .. "Warning Repetition: " .. repeats)
		end
		return
	end
	
	if not isempty(args) then
		if isNumeric(args) == true then
			if cmd == "setw" then
				if tonumber(args) >= rewarn then
					print("|cffff0000Warning percentage must be lower then Rewarn percentage")
					return
				end
				print("|cff00ff00Setted Warning Percentage to " .. args)
				warning = tonumber(args)
				ManaNotifierDB.warning = tonumber(args)
				return
			elseif cmd == "setrew" then
				if tonumber(args) > ready then
					print("|cffff0000Rewarn percentage must be lower or equal to Ready percentage")
					return
				end
				if tonumber(args) <= warning then
					print("|cffff0000Rewarn percentage must be greater then Warning percentage")
					return
				end
				print("|cff00ff00Setted Rewarn Percentage to " .. args)
				rewarn = tonumber(args)
				ManaNotifierDB.rewarn = tonumber(args)
				return
			elseif cmd == "setr" then
				if tonumber(args) < rewarn then
					print("|cffff0000Ready percentage must be greater or equal to Rewarn percentage")
					return
				end
				print("|cff00ff00Setted Ready Percentage to " .. args)
				ready = tonumber(args)
				ManaNotifierDB.ready = tonumber(args)
				return
			elseif cmd == "setrep" then
				if tonumber(args) < 1 or tonumber(args) > 3 then
					print("|cffff0000Repeat Value can only be between 1 and 3")
					return
				end
				print("|cff00ff00Setted Repeat Value to " .. args)
				repeats = tonumber(args)
				ManaNotifierDB.repeats = tonumber(args)
				return
			end
		else
			print("|cffff0000Argument must be a Number")
			return
		end
	end
	
	print("|cff2020ffManaNotifier|r\n/mn start -> Start ManaNotifier \n/mn stop -> Stop ManaNotifier \n/mn setw <val> -> Warning percent \n/mn setrew <val> -> Rewarn after \n/mn setr <val> -> Ready after\n/mn setrep <val> -> Set Warning-Message repetition\n/mn info -> Show setted values");
end

SLASH_MN1 = '/mn'

SlashCmdList["MN"] = AddonCommands

local function mn()
	mana = UnitPower("player" , Enum.PowerType.Mana)
	manaMax = UnitPowerMax("player" , Enum.PowerType.Mana)
	percent = (100 / manaMax) * mana
	if percent >= ready then
		if sendReady == false then
			sendMessage("[ManaNotifier] Ready! (" .. floor(percent) .. "%)")
			sendReady = true
		end
	end
	if percent >= rewarn then
		sendWarning = false
	end
	if percent <= warning then
		if sendWarning == false then
			text = "[ManaNotifier] MANA LOW! (" .. floor(percent) .. "%)"
			for i = 1, repeats, 1 do
				sendMessage(text)
			end
			sendWarning = true
			sendReady = false
		end
	end
end

local frame = CreateFrame("FRAME", "ManaNotifier");
frame:RegisterEvent("UNIT_POWER");
frame:RegisterEvent("ADDON_LOADED");
local function eventHandler(self, event, addon, what, ...)
	if event == "UNIT_POWER" then
		if what == "MANA" then
			if active == true then
				mn()
			end
		end
	end
	if event == "ADDON_LOADED" and addon == "ManaNotifier" then
		active = ManaNotifierDB.active
		warning = ManaNotifierDB.warning
		rewarn = ManaNotifierDB.rewarn
		ready = ManaNotifierDB.ready
		repeats = ManaNotifierDB.repeats
		if active == nil then
			active = true
		end
		if warning == nil then
			warning = 10
		end
		if rewarn == nil then
			rewarn = 20
		end
		if ready == nil then
			ready = 60
		end
		if repeats == nil then
			repeats = 2
		end
		
		if active then
			print("|cff2020ffManaNotifier|r activated!\n/mn -> List Commands")
		else
			print("|cff2020ffManaNotifier|r deactivated, activate with  /mn start\n /mn -> List Commands")
		end
	end
end
frame:SetScript("OnEvent", eventHandler);



